Index: issm/trunk-jpl/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Tria.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/Tria.cpp	(revision 15564)
@@ -193,6 +193,6 @@
 			Ke=CreateKMatrixDiagnosticMacAyeal();
 			break;
-		case DiagnosticHutterAnalysisEnum:
-			Ke=CreateKMatrixDiagnosticHutter();
+		case DiagnosticSIAAnalysisEnum:
+			Ke=CreateKMatrixDiagnosticSIA();
 			break;
 		 #endif
@@ -306,6 +306,6 @@
 			pe=CreatePVectorDiagnosticMacAyeal();
 			break;
-		case DiagnosticHutterAnalysisEnum:
-			pe=CreatePVectorDiagnosticHutter();
+		case DiagnosticSIAAnalysisEnum:
+			pe=CreatePVectorDiagnosticSIA();
 			break;
 		#endif
@@ -423,5 +423,5 @@
 #ifdef _HAVE_DIAGNOSTIC_
 		case DiagnosticHorizAnalysisEnum:
-			Ke=CreateJacobianDiagnosticMacayeal();
+			Ke=CreateJacobianDiagnosticSSA();
 			break;
 #endif
@@ -1201,6 +1201,6 @@
 		GetSolutionFromInputsDiagnosticHoriz(solution);
 		break;
-	case DiagnosticHutterAnalysisEnum:
-		GetSolutionFromInputsDiagnosticHutter(solution);
+	case DiagnosticSIAAnalysisEnum:
+		GetSolutionFromInputsDiagnosticSIA(solution);
 		break;
 	#endif
@@ -1522,5 +1522,5 @@
 			InputUpdateFromSolutionDiagnosticHoriz(solution);
 			break;
-		case DiagnosticHutterAnalysisEnum:
+		case DiagnosticSIAAnalysisEnum:
 			InputUpdateFromSolutionDiagnosticHoriz(solution);
 			break;
@@ -2343,5 +2343,5 @@
 	iomodel->Constant(&progstabilization,PrognosticStabilizationEnum);
 	iomodel->Constant(&balancestabilization,BalancethicknessStabilizationEnum);
-	iomodel->Constant(&fe_ssa,FlowequationFeSsaEnum);
+	iomodel->Constant(&fe_ssa,FlowequationFeSSAEnum);
 	iomodel->Constant(&dakota_analysis,QmuIsdakotaEnum);
 
@@ -3055,6 +3055,6 @@
 }
 /*}}}*/
-/*FUNCTION Tria::CreateKMatrixDiagnosticHutter{{{*/
-ElementMatrix* Tria::CreateKMatrixDiagnosticHutter(void){
+/*FUNCTION Tria::CreateKMatrixDiagnosticSIA{{{*/
+ElementMatrix* Tria::CreateKMatrixDiagnosticSIA(void){
 
 	/*Intermediaries*/
@@ -3224,6 +3224,6 @@
 }
 /*}}}*/
-/*FUNCTION Tria::CreatePVectorDiagnosticHutter{{{*/
-ElementVector* Tria::CreatePVectorDiagnosticHutter(void){
+/*FUNCTION Tria::CreatePVectorDiagnosticSIA{{{*/
+ElementVector* Tria::CreatePVectorDiagnosticSIA(void){
 
 	/*Intermediaries */
@@ -3274,6 +3274,6 @@
 }
 /*}}}*/
-/*FUNCTION Tria::CreateJacobianDiagnosticMacayeal{{{*/
-ElementMatrix* Tria::CreateJacobianDiagnosticMacayeal(void){
+/*FUNCTION Tria::CreateJacobianDiagnosticSSA{{{*/
+ElementMatrix* Tria::CreateJacobianDiagnosticSSA(void){
 
 	/*Intermediaries */
@@ -3382,6 +3382,6 @@
 }
 /*}}}*/
-/*FUNCTION Tria::GetSolutionFromInputsDiagnosticHutter{{{*/
-void  Tria::GetSolutionFromInputsDiagnosticHutter(Vector<IssmDouble>* solution){
+/*FUNCTION Tria::GetSolutionFromInputsDiagnosticSIA{{{*/
+void  Tria::GetSolutionFromInputsDiagnosticSIA(Vector<IssmDouble>* solution){
 
 	const int    numdof=NDOF2*NUMVERTICES;
@@ -3494,6 +3494,6 @@
 }
 /*}}}*/
-/*FUNCTION Tria::InputUpdateFromSolutionDiagnosticHutter {{{*/
-void  Tria::InputUpdateFromSolutionDiagnosticHutter(IssmDouble* solution){
+/*FUNCTION Tria::InputUpdateFromSolutionDiagnosticSIA {{{*/
+void  Tria::InputUpdateFromSolutionDiagnosticSIA(IssmDouble* solution){
 
 	int        i;
@@ -5137,6 +5137,6 @@
 }
 /*}}}*/
-/*FUNCTION Tria::CreatePVectorAdjointStokes{{{*/
-ElementVector* Tria::CreatePVectorAdjointStokes(void){
+/*FUNCTION Tria::CreatePVectorAdjointFS{{{*/
+ElementVector* Tria::CreatePVectorAdjointFS(void){
 
 	/*Intermediaries */
@@ -5156,5 +5156,5 @@
 
 	/*Initialize Element vector*/
-	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,StokesApproximationEnum);
+	ElementVector* pe=new ElementVector(nodes,NUMVERTICES,this->parameters,FSApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
Index: issm/trunk-jpl/src/c/classes/Elements/Tria.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/Tria.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/Tria.h	(revision 15564)
@@ -147,5 +147,5 @@
 		void   GradjZMacAyeal(Vector<IssmDouble>* gradient,int control_index);
 		void   GradjDragMacAyeal(Vector<IssmDouble>* gradient,int control_index);
-		void   GradjDragStokes(Vector<IssmDouble>* gradient,int control_index);
+		void   GradjDragFS(Vector<IssmDouble>* gradient,int control_index);
 		void   GradjDragGradient(Vector<IssmDouble>* gradient,int weight_index,int control_index);
 		void   GradjDhDtBalancedthickness(Vector<IssmDouble>* gradient,int control_index);
@@ -223,14 +223,14 @@
 		ElementMatrix* CreateKMatrixDiagnosticMacAyealViscous(void);
 		ElementMatrix* CreateKMatrixDiagnosticMacAyealFriction(void);
-		ElementMatrix* CreateKMatrixDiagnosticHutter(void);
+		ElementMatrix* CreateKMatrixDiagnosticSIA(void);
 		ElementVector* CreatePVectorDiagnosticMacAyeal(void);
 		ElementVector* CreatePVectorDiagnosticMacAyealDrivingStress(void);
 		ElementVector* CreatePVectorDiagnosticMacAyealFront(void);
-		ElementVector* CreatePVectorDiagnosticHutter(void);
-		ElementMatrix* CreateJacobianDiagnosticMacayeal(void);
+		ElementVector* CreatePVectorDiagnosticSIA(void);
+		ElementMatrix* CreateJacobianDiagnosticSSA(void);
 		void	  GetSolutionFromInputsDiagnosticHoriz(Vector<IssmDouble>* solution);
-		void	  GetSolutionFromInputsDiagnosticHutter(Vector<IssmDouble>* solution);
+		void	  GetSolutionFromInputsDiagnosticSIA(Vector<IssmDouble>* solution);
 		void	  InputUpdateFromSolutionDiagnosticHoriz( IssmDouble* solution);
-		void	  InputUpdateFromSolutionDiagnosticHutter( IssmDouble* solution);
+		void	  InputUpdateFromSolutionDiagnosticSIA( IssmDouble* solution);
 		#endif
 
@@ -239,5 +239,5 @@
 		ElementMatrix* CreateKMatrixAdjointMacAyeal(void);
 		ElementVector* CreatePVectorAdjointHoriz(void);
-		ElementVector* CreatePVectorAdjointStokes(void);
+		ElementVector* CreatePVectorAdjointFS(void);
 		ElementVector* CreatePVectorAdjointBalancethickness(void);
 		void	  InputUpdateFromSolutionAdjointBalancethickness( IssmDouble* solution);
Index: issm/trunk-jpl/src/c/classes/Elements/TriaRef.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/TriaRef.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/TriaRef.cpp	(revision 15564)
@@ -114,6 +114,6 @@
 }
 /*}}}*/
-/*FUNCTION TriaRef::GetBMacAyealStokes {{{*/
-void TriaRef::GetBMacAyealStokes(IssmDouble* B, IssmDouble* xyz_list, GaussTria* gauss){
+/*FUNCTION TriaRef::GetBMacAyealFS {{{*/
+void TriaRef::GetBMacAyealFS(IssmDouble* B, IssmDouble* xyz_list, GaussTria* gauss){
 
 	/*Compute B  matrix. B=[B1 B2 B3] where Bi is of size 3*NDOF2. 
@@ -265,6 +265,6 @@
 }
 /*}}}*/
-/*FUNCTION TriaRef::GetBprimeMacAyealStokes {{{*/
-void TriaRef::GetBprimeMacAyealStokes(IssmDouble* Bprime, IssmDouble* xyz_list, GaussTria* gauss){
+/*FUNCTION TriaRef::GetBprimeMacAyealFS {{{*/
+void TriaRef::GetBprimeMacAyealFS(IssmDouble* Bprime, IssmDouble* xyz_list, GaussTria* gauss){
 	/*Compute Bprime  matrix. Bprime=[Bprime1 Bprime2 Bprime3] where Bprimei is of size 3*NDOF2. 
 	 * For node i, Bprimei can be expressed in the actual coordinate system
Index: issm/trunk-jpl/src/c/classes/Elements/TriaRef.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Elements/TriaRef.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Elements/TriaRef.h	(revision 15564)
@@ -24,7 +24,7 @@
 		/*Numerics*/
 		void GetBMacAyeal(IssmDouble* B, IssmDouble* xyz_list, GaussTria* gauss);
-		void GetBMacAyealStokes(IssmDouble* B , IssmDouble* xyz_list, GaussTria* gauss);
+		void GetBMacAyealFS(IssmDouble* B , IssmDouble* xyz_list, GaussTria* gauss);
 		void GetBprimeMacAyeal(IssmDouble* Bprime, IssmDouble* xyz_list, GaussTria* gauss);
-		void GetBprimeMacAyealStokes(IssmDouble* Bprime, IssmDouble* xyz_list, GaussTria* gauss);
+		void GetBprimeMacAyealFS(IssmDouble* Bprime, IssmDouble* xyz_list, GaussTria* gauss);
 		void GetBprimePrognostic(IssmDouble* Bprime, IssmDouble* xyz_list, GaussTria* gauss);
 		void GetBPrognostic(IssmDouble* B, IssmDouble* xyz_list, GaussTria* gauss);
Index: issm/trunk-jpl/src/c/classes/Inputs/BoolInput.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/BoolInput.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/BoolInput.h	(revision 15564)
@@ -62,6 +62,6 @@
 		void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void ChangeEnum(int newenumtype);
 		void SquareMin(IssmDouble* psquaremin, Parameters* parameters);
Index: issm/trunk-jpl/src/c/classes/Inputs/ControlInput.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/ControlInput.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/ControlInput.h	(revision 15564)
@@ -67,6 +67,6 @@
 		void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void ChangeEnum(int newenumtype){_error_("not implemented yet");};
 		void SquareMin(IssmDouble* psquaremin,Parameters* parameters){_error_("not implemented yet");};
Index: issm/trunk-jpl/src/c/classes/Inputs/DatasetInput.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/DatasetInput.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/DatasetInput.h	(revision 15564)
@@ -61,6 +61,6 @@
 		void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void ChangeEnum(int newenumtype){_error_("not implemented yet");};
 		void SquareMin(IssmDouble* psquaremin,Parameters* parameters){_error_("not implemented yet");};
Index: issm/trunk-jpl/src/c/classes/Inputs/DoubleInput.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/DoubleInput.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/DoubleInput.cpp	(revision 15564)
@@ -156,12 +156,12 @@
 }
 /*}}}*/
-/*FUNCTION DoubleInput::GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){{{*/
-void DoubleInput::GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION DoubleInput::GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){{{*/
+void DoubleInput::GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){
 	/*Epsilon is zero as vx is constant over the element*/
 	for(int i=0;i<5;i++) epsilonvx[i]=0;
 }
 /*}}}*/
-/*FUNCTION DoubleInput::GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){{{*/
-void DoubleInput::GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION DoubleInput::GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){{{*/
+void DoubleInput::GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){
 	/*Epsilon is zero as vy is constant over the element*/
 	for(int i=0;i<5;i++) epsilonvy[i]=0;
Index: issm/trunk-jpl/src/c/classes/Inputs/DoubleInput.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/DoubleInput.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/DoubleInput.h	(revision 15564)
@@ -61,6 +61,6 @@
 		void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss);
 		void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss);
 		void ChangeEnum(int newenumtype);
 		void SquareMin(IssmDouble* psquaremin,Parameters* parameters);
Index: issm/trunk-jpl/src/c/classes/Inputs/Input.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/Input.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/Input.h	(revision 15564)
@@ -44,6 +44,6 @@
 		virtual void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss)=0;
 		virtual void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss)=0;
-		virtual void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss)=0;
-		virtual void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss)=0;
+		virtual void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss)=0;
+		virtual void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss)=0;
 		virtual void ChangeEnum(int newenumtype)=0;
 		virtual void Configure(Parameters* parameters)=0;
Index: issm/trunk-jpl/src/c/classes/Inputs/IntInput.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/IntInput.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/IntInput.h	(revision 15564)
@@ -63,6 +63,6 @@
 		void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void ChangeEnum(int newenumtype);
 		void SquareMin(IssmDouble* psquaremin,Parameters* parameters);
Index: issm/trunk-jpl/src/c/classes/Inputs/PentaInput.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/PentaInput.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/PentaInput.cpp	(revision 15564)
@@ -145,5 +145,5 @@
 
 	/*Get B matrix: */
-	GetBStokes(&B[0][0], xyz_list, gauss);
+	GetBFS(&B[0][0], xyz_list, gauss);
 
 	/*Create a reduced matrix of B to get rid of pressure */
@@ -193,5 +193,5 @@
 
 	/*Get B matrix: */
-	GetBStokes(&B[0][0], xyz_list, gauss);
+	GetBFS(&B[0][0], xyz_list, gauss);
 	/*Create a reduced matrix of B to get rid of pressure */
 	for (i=0;i<6;i++){
@@ -238,5 +238,5 @@
 
 	/*Get B matrix: */
-	GetBStokes(&B[0][0], xyz_list, gauss);
+	GetBFS(&B[0][0], xyz_list, gauss);
 
 	_assert_(this->NumberofNodes()==6); //Check Tria too
@@ -276,6 +276,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::GetVxStrainRate3dPattyn{{{*/
-void PentaInput::GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaInput::GetVxStrainRate3dHO{{{*/
+void PentaInput::GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){
 
 	int i;
@@ -285,5 +285,5 @@
 
 	/*Get B matrix: */
-	GetBPattyn(&B[0][0], xyz_list, gauss);
+	GetBHO(&B[0][0], xyz_list, gauss);
 
 	_assert_(this->NumberofNodes()==6); //Check Tria too
@@ -303,6 +303,6 @@
 }
 /*}}}*/
-/*FUNCTION PentaInput::GetVyStrainRate3dPattyn{{{*/
-void PentaInput::GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){
+/*FUNCTION PentaInput::GetVyStrainRate3dHO{{{*/
+void PentaInput::GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){
 
 	int i;
@@ -312,5 +312,5 @@
 
 	/*Get B matrix: */
-	GetBPattyn(&B[0][0], xyz_list, gauss);
+	GetBHO(&B[0][0], xyz_list, gauss);
 
 	_assert_(this->NumberofNodes()==6); //Check Tria too
Index: issm/trunk-jpl/src/c/classes/Inputs/PentaInput.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/PentaInput.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/PentaInput.h	(revision 15564)
@@ -62,6 +62,6 @@
 		void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss);
 		void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss);
-		void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss);
+		void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss);
 		void ChangeEnum(int newenumtype);
 
Index: issm/trunk-jpl/src/c/classes/Inputs/TransientInput.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/TransientInput.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/TransientInput.h	(revision 15564)
@@ -65,6 +65,6 @@
 		void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void ChangeEnum(int newenumtype);
 
Index: issm/trunk-jpl/src/c/classes/Inputs/TriaInput.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Inputs/TriaInput.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Inputs/TriaInput.h	(revision 15564)
@@ -62,6 +62,6 @@
 		void GetVyStrainRate3d(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void GetVzStrainRate3d(IssmDouble* epsilonvz,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVxStrainRate3dPattyn(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
-		void GetVyStrainRate3dPattyn(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVxStrainRate3dHO(IssmDouble* epsilonvx,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
+		void GetVyStrainRate3dHO(IssmDouble* epsilonvy,IssmDouble* xyz_list, GaussPenta* gauss){_error_("not implemented yet");};
 		void ChangeEnum(int newenumtype);
 
Index: issm/trunk-jpl/src/c/classes/Loads/Icefront.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Loads/Icefront.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Loads/Icefront.cpp	(revision 15564)
@@ -75,5 +75,5 @@
 		icefront_vertex_ids[1]=reCast<int>(*(iomodel->Data(DiagnosticIcefrontEnum)+segment_width*i+1));
 	}
-	else if (in_icefront_type==PattynIceFrontEnum || in_icefront_type==StokesIceFrontEnum){
+	else if (in_icefront_type==HOIceFrontEnum || in_icefront_type==FSIceFrontEnum){
 		numnodes    = 4;
 		numvertices = 4;
@@ -158,5 +158,5 @@
 //		icefront_vertex_ids[1]=reCast<int>(*(iomodel->Data(DiagnosticIcefrontEnum)+segment_width*i+1));
 	}
-	else if (in_icefront_type==PattynIceFrontEnum || in_icefront_type==StokesIceFrontEnum){
+	else if (in_icefront_type==HOIceFrontEnum || in_icefront_type==FSIceFrontEnum){
 //		icefront_node_ids[0]=iomodel->nodecounter+reCast<int>(*(iomodel->Data(DiagnosticIcefrontEnum)+segment_width*i+0));
 //		icefront_node_ids[1]=iomodel->nodecounter+reCast<int>(*(iomodel->Data(DiagnosticIcefrontEnum)+segment_width*i+1));
@@ -170,5 +170,5 @@
 	else _error_("in_icefront_type " << EnumToStringx(in_icefront_type) << " not supported yet!");
 
-	if (in_icefront_type==PattynIceFrontEnum || in_icefront_type==StokesIceFrontEnum){
+	if (in_icefront_type==HOIceFrontEnum || in_icefront_type==FSIceFrontEnum){
 		numnodes=4;
 		numvertices=4;
@@ -380,6 +380,6 @@
 			return;
 #ifdef _HAVE_3D_
-		case PattynIceFrontEnum:
-		case StokesIceFrontEnum:
+		case HOIceFrontEnum:
+		case FSIceFrontEnum:
 			for(int i=0;i<NUMVERTICESQUA;i++) sidlist[i]=nodes[i]->Sid();
 			return;
@@ -402,7 +402,7 @@
 		case MacAyeal3dIceFrontEnum:
 			return NUMVERTICESSEG;
-		case PattynIceFrontEnum:
+		case HOIceFrontEnum:
 			return NUMVERTICESQUA;
-		case StokesIceFrontEnum:
+		case FSIceFrontEnum:
 			return NUMVERTICESQUA;
 #endif
@@ -564,8 +564,8 @@
 		case MacAyeal3dIceFrontEnum:
 			return CreatePVectorDiagnosticMacAyeal3d();
-		case PattynIceFrontEnum:
-			return CreatePVectorDiagnosticPattyn();
-		case StokesIceFrontEnum:
-			return CreatePVectorDiagnosticStokes();
+		case HOIceFrontEnum:
+			return CreatePVectorDiagnosticHO();
+		case FSIceFrontEnum:
+			return CreatePVectorDiagnosticFS();
 	    #endif
 		default:
@@ -696,6 +696,6 @@
 }
 /*}}}*/
-/*FUNCTION Icefront::CreatePVectorDiagnosticPattyn{{{*/
-ElementVector* Icefront::CreatePVectorDiagnosticPattyn(void){
+/*FUNCTION Icefront::CreatePVectorDiagnosticHO{{{*/
+ElementVector* Icefront::CreatePVectorDiagnosticHO(void){
 
 	/*Constants*/
@@ -717,5 +717,5 @@
 	/*Initialize Element vector and return if necessary*/
 	if(penta->IsOnWater()) return NULL;
-	ElementVector* pe=new ElementVector(nodes,NUMVERTICESQUA,this->parameters,PattynApproximationEnum);
+	ElementVector* pe=new ElementVector(nodes,NUMVERTICESQUA,this->parameters,HOApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
@@ -773,6 +773,6 @@
 }
 /*}}}*/
-/*FUNCTION Icefront::CreatePVectorDiagnosticStokes{{{*/
-ElementVector* Icefront::CreatePVectorDiagnosticStokes(void){
+/*FUNCTION Icefront::CreatePVectorDiagnosticFS{{{*/
+ElementVector* Icefront::CreatePVectorDiagnosticFS(void){
 
 	/*Constants*/
@@ -794,5 +794,5 @@
 	/*Initialize Element vector and return if necessary*/
 	if(penta->IsOnWater()) return NULL;
-	ElementVector* pe=new ElementVector(nodes,NUMVERTICESQUA,this->parameters,StokesApproximationEnum);
+	ElementVector* pe=new ElementVector(nodes,NUMVERTICESQUA,this->parameters,FSApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
@@ -833,5 +833,5 @@
 		}
 		air_pressure=0;
-		pressure = water_pressure + air_pressure; //no ice pressure fore Stokes
+		pressure = water_pressure + air_pressure; //no ice pressure fore FS
 
 		for(i=0;i<NUMVERTICESQUA;i++){
Index: issm/trunk-jpl/src/c/classes/Loads/Icefront.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Loads/Icefront.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Loads/Icefront.h	(revision 15564)
@@ -97,6 +97,6 @@
         #ifdef _HAVE_3D_
 		ElementVector* CreatePVectorDiagnosticMacAyeal3d(void);
-		ElementVector* CreatePVectorDiagnosticPattyn(void);
-		ElementVector* CreatePVectorDiagnosticStokes(void);
+		ElementVector* CreatePVectorDiagnosticHO(void);
+		ElementVector* CreatePVectorDiagnosticFS(void);
 	    #endif
 		/*}}}*/
Index: issm/trunk-jpl/src/c/classes/Loads/Pengrid.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Loads/Pengrid.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Loads/Pengrid.cpp	(revision 15564)
@@ -223,5 +223,5 @@
 		#ifdef _HAVE_DIAGNOSTIC_
 		case DiagnosticHorizAnalysisEnum: case AdjointHorizAnalysisEnum:
-			Ke=PenaltyCreateKMatrixDiagnosticStokes(kmax);
+			Ke=PenaltyCreateKMatrixDiagnosticFS(kmax);
 			break;
 		#endif
@@ -449,6 +449,6 @@
 /*}}}*/
 #ifdef _HAVE_DIAGNOSTIC_
-/*FUNCTION Pengrid::PenaltyCreateKMatrixDiagnosticStokes {{{*/
-ElementMatrix* Pengrid::PenaltyCreateKMatrixDiagnosticStokes(IssmDouble kmax){
+/*FUNCTION Pengrid::PenaltyCreateKMatrixDiagnosticFS {{{*/
+ElementMatrix* Pengrid::PenaltyCreateKMatrixDiagnosticFS(IssmDouble kmax){
 
 	const int numdof = NUMVERTICES *NDOF4;
@@ -461,6 +461,6 @@
 	/*Initialize Element vector and return if necessary*/
 	penta->inputs->GetInputValue(&approximation,ApproximationEnum);
-	if(approximation!=StokesApproximationEnum &&  approximation!=PattynStokesApproximationEnum) return NULL;
-	ElementMatrix* Ke=new ElementMatrix(&node,1,this->parameters,StokesApproximationEnum);
+	if(approximation!=FSApproximationEnum &&  approximation!=HOFSApproximationEnum) return NULL;
+	ElementMatrix* Ke=new ElementMatrix(&node,1,this->parameters,FSApproximationEnum);
 
 	/*Retrieve all inputs and parameters*/
Index: issm/trunk-jpl/src/c/classes/Loads/Pengrid.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Loads/Pengrid.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Loads/Pengrid.h	(revision 15564)
@@ -88,5 +88,5 @@
 		/*Pengrid management {{{*/
 		#ifdef _HAVE_DIAGNOSTIC_
-		ElementMatrix* PenaltyCreateKMatrixDiagnosticStokes(IssmDouble kmax);
+		ElementMatrix* PenaltyCreateKMatrixDiagnosticFS(IssmDouble kmax);
 		#endif
 		#ifdef _HAVE_THERMAL_
Index: issm/trunk-jpl/src/c/classes/Loads/Penpair.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Loads/Penpair.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Loads/Penpair.cpp	(revision 15564)
@@ -301,24 +301,24 @@
 		case MacAyealApproximationEnum:
 			switch(approximation1){
-				case MacAyealApproximationEnum: return PenaltyCreateKMatrixDiagnosticMacAyealPattyn(kmax); 
-				case PattynApproximationEnum:   return PenaltyCreateKMatrixDiagnosticMacAyealPattyn(kmax); 
+				case MacAyealApproximationEnum: return PenaltyCreateKMatrixDiagnosticMacAyealHO(kmax); 
+				case HOApproximationEnum:   return PenaltyCreateKMatrixDiagnosticMacAyealHO(kmax); 
 				default: _error_("not supported yet");
 			}
-		case PattynApproximationEnum:
+		case HOApproximationEnum:
 			switch(approximation1){
-				case MacAyealApproximationEnum: return PenaltyCreateKMatrixDiagnosticMacAyealPattyn(kmax); 
-				case PattynApproximationEnum:   return PenaltyCreateKMatrixDiagnosticMacAyealPattyn(kmax); 
+				case MacAyealApproximationEnum: return PenaltyCreateKMatrixDiagnosticMacAyealHO(kmax); 
+				case HOApproximationEnum:   return PenaltyCreateKMatrixDiagnosticMacAyealHO(kmax); 
 				default: _error_("not supported yet");
 			}
-		case StokesApproximationEnum:
+		case FSApproximationEnum:
 			switch(approximation1){
-				case StokesApproximationEnum: return PenaltyCreateKMatrixDiagnosticStokes(kmax); 
-				case NoneApproximationEnum: return   PenaltyCreateKMatrixDiagnosticStokes(kmax); 
+				case FSApproximationEnum: return PenaltyCreateKMatrixDiagnosticFS(kmax); 
+				case NoneApproximationEnum: return   PenaltyCreateKMatrixDiagnosticFS(kmax); 
 				default: _error_("not supported yet");
 			}
 		case NoneApproximationEnum:
 			switch(approximation1){
-				case StokesApproximationEnum: return PenaltyCreateKMatrixDiagnosticStokes(kmax); 
-				case NoneApproximationEnum: return   PenaltyCreateKMatrixDiagnosticStokes(kmax); 
+				case FSApproximationEnum: return PenaltyCreateKMatrixDiagnosticFS(kmax); 
+				case NoneApproximationEnum: return   PenaltyCreateKMatrixDiagnosticFS(kmax); 
 				default: _error_("not supported yet");
 			}
@@ -327,6 +327,6 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::PenaltyCreateKMatrixDiagnosticMacAyealPattyn {{{*/
-ElementMatrix* Penpair::PenaltyCreateKMatrixDiagnosticMacAyealPattyn(IssmDouble kmax){
+/*FUNCTION Penpair::PenaltyCreateKMatrixDiagnosticMacAyealHO {{{*/
+ElementMatrix* Penpair::PenaltyCreateKMatrixDiagnosticMacAyealHO(IssmDouble kmax){
 
 	const int numdof=NUMVERTICES*NDOF2;
@@ -354,6 +354,6 @@
 }
 /*}}}*/
-/*FUNCTION Penpair::PenaltyCreateKMatrixDiagnosticStokes {{{*/
-ElementMatrix* Penpair::PenaltyCreateKMatrixDiagnosticStokes(IssmDouble kmax){
+/*FUNCTION Penpair::PenaltyCreateKMatrixDiagnosticFS {{{*/
+ElementMatrix* Penpair::PenaltyCreateKMatrixDiagnosticFS(IssmDouble kmax){
 
 	const int numdof=NUMVERTICES*NDOF4;
Index: issm/trunk-jpl/src/c/classes/Loads/Penpair.h
===================================================================
--- issm/trunk-jpl/src/c/classes/Loads/Penpair.h	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Loads/Penpair.h	(revision 15564)
@@ -68,6 +68,6 @@
 			/*Penpair management: {{{*/
 		ElementMatrix* PenaltyCreateKMatrixDiagnosticHoriz(IssmDouble kmax);
-		ElementMatrix* PenaltyCreateKMatrixDiagnosticMacAyealPattyn(IssmDouble kmax);
-		ElementMatrix* PenaltyCreateKMatrixDiagnosticStokes(IssmDouble kmax);
+		ElementMatrix* PenaltyCreateKMatrixDiagnosticMacAyealHO(IssmDouble kmax);
+		ElementMatrix* PenaltyCreateKMatrixDiagnosticFS(IssmDouble kmax);
 		ElementMatrix* PenaltyCreateKMatrixPrognostic(IssmDouble kmax);
 		/*}}}*/
Index: issm/trunk-jpl/src/c/classes/Materials/Matdamageice.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Materials/Matdamageice.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/classes/Materials/Matdamageice.cpp	(revision 15564)
@@ -351,6 +351,6 @@
 }
 /*}}}*/
-/*FUNCTION Matdamageice::GetViscosity3dStokes {{{*/
-void  Matdamageice::GetViscosity3dStokes(IssmDouble* pviscosity3d, IssmDouble* epsilon){
+/*FUNCTION Matdamageice::GetViscosity3dFS {{{*/
+void  Matdamageice::GetViscosity3dFS(IssmDouble* pviscosity3d, IssmDouble* epsilon){
 	/*Return viscosity accounting for steady state power law creep [Thomas and MacAyeal, 1982]: 
 	 *
